Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Plugin.cs.frame
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Plugin.cs.frame	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Plugin.cs.frame	(revision 7538)
@@ -36,4 +36,6 @@
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
   [PluginDependency("HeuristicLab.Problems.GeneralizedQuadraticAssignment.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Random", "3.3")]
+  [PluginDependency("HeuristicLab.Selection", "3.3")]
   public class HeuristicLabProblemsGeneralizedQuadraticAssignmentAlgorithmsPlugin : PluginBase {
   }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Common/3.3/Plugin.cs.frame
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Common/3.3/Plugin.cs.frame	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Common/3.3/Plugin.cs.frame	(revision 7538)
@@ -25,4 +25,14 @@
   [Plugin("HeuristicLab.Problems.GeneralizedQuadraticAssignment.Common", "3.3.0.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.GeneralizedQuadraticAssignment.Common-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.IntegerVectorEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
   public class HeuristicLabProblemsGeneralizedQuadraticAssignmentCommonPlugin : PluginBase {
   }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/Plugin.cs.frame
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/Plugin.cs.frame	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/Plugin.cs.frame	(revision 7538)
@@ -25,4 +25,5 @@
   [Plugin("HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views", "3.3.6.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Common", "3.3")]
   [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
@@ -30,4 +31,5 @@
   [PluginDependency("HeuristicLab.Core.Views", "3.3")]
   [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Data.Views", "3.3")]
   [PluginDependency("HeuristicLab.Encodings.IntegerVectorEncoding", "3.3")]
   [PluginDependency("HeuristicLab.MainForm", "3.3")]
@@ -37,4 +39,6 @@
   [PluginDependency("HeuristicLab.Parameters", "3.3")]
   [PluginDependency("HeuristicLab.Problems.GeneralizedQuadraticAssignment", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.Instances", "3.3")]
+  [PluginDependency("HeuristicLab.Visualization.ChartControlsExtensions", "3.3")]
   public class HeuristicLabProblemsGeneralizedQuadraticAssignmentViewsPlugin : PluginBase {
   }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemInstanceProviderView.Designer.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemInstanceProviderView.Designer.cs	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemInstanceProviderView.Designer.cs	(revision 7538)
@@ -21,5 +21,5 @@
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views {
-  partial class ProblemInstanceProviderView {
+  partial class ProblemInstanceProviderView<T> {
     /// <summary> 
     /// Required designer variable.
@@ -48,4 +48,6 @@
       this.label2 = new System.Windows.Forms.Label();
       this.instancesComboBox = new System.Windows.Forms.ComboBox();
+      this.importButton = new System.Windows.Forms.Button();
+      this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
       this.SuspendLayout();
       // 
@@ -53,5 +55,5 @@
       // 
       this.loadButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.loadButton.Location = new System.Drawing.Point(535, -1);
+      this.loadButton.Location = new System.Drawing.Point(451, -1);
       this.loadButton.Name = "loadButton";
       this.loadButton.Size = new System.Drawing.Size(75, 23);
@@ -78,7 +80,23 @@
       this.instancesComboBox.Location = new System.Drawing.Point(54, 0);
       this.instancesComboBox.Name = "instancesComboBox";
-      this.instancesComboBox.Size = new System.Drawing.Size(475, 21);
+      this.instancesComboBox.Size = new System.Drawing.Size(391, 21);
       this.instancesComboBox.TabIndex = 7;
       this.instancesComboBox.DataSourceChanged += new System.EventHandler(this.comboBox_DataSourceChanged);
+      // 
+      // importButton
+      // 
+      this.importButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.importButton.Location = new System.Drawing.Point(532, -1);
+      this.importButton.Name = "importButton";
+      this.importButton.Size = new System.Drawing.Size(75, 23);
+      this.importButton.TabIndex = 6;
+      this.importButton.Text = "Import";
+      this.importButton.TextImageRelation = System.Windows.Forms.TextImageRelation.ImageBeforeText;
+      this.importButton.UseVisualStyleBackColor = true;
+      this.importButton.Click += new System.EventHandler(this.importButton_Click);
+      // 
+      // openFileDialog
+      // 
+      this.openFileDialog.Filter = "All files|*.*";
       // 
       // ProblemInstanceProviderView
@@ -87,4 +105,5 @@
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
       this.Controls.Add(this.instancesComboBox);
+      this.Controls.Add(this.importButton);
       this.Controls.Add(this.loadButton);
       this.Controls.Add(this.label2);
@@ -101,4 +120,6 @@
     private System.Windows.Forms.Label label2;
     private System.Windows.Forms.ComboBox instancesComboBox;
+    private System.Windows.Forms.Button importButton;
+    private System.Windows.Forms.OpenFileDialog openFileDialog;
 
   }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemInstanceProviderView.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemInstanceProviderView.cs	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemInstanceProviderView.cs	(revision 7538)
@@ -23,4 +23,5 @@
 using System.Linq;
 using System.Windows.Forms;
+using HeuristicLab.Common.Resources;
 using HeuristicLab.MainForm;
 using HeuristicLab.MainForm.WindowsForms;
@@ -29,9 +30,9 @@
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views {
   [View("ProblemInstanceProviderView")]
-  [Content(typeof(IProblemInstanceProvider), IsDefaultView = true)]
-  public partial class ProblemInstanceProviderView : AsynchronousContentView {
+  [Content(typeof(IProblemInstanceProvider<>), IsDefaultView = true)]
+  public partial class ProblemInstanceProviderView<T> : AsynchronousContentView {
 
-    public new IProblemInstanceProvider Content {
-      get { return (IProblemInstanceProvider)base.Content; }
+    public new IProblemInstanceProvider<T> Content {
+      get { return (IProblemInstanceProvider<T>)base.Content; }
       set { base.Content = value; }
     }
@@ -39,4 +40,5 @@
     public ProblemInstanceProviderView() {
       InitializeComponent();
+      importButton.Image = VSImageLibrary.Open;
     }
 
@@ -53,12 +55,32 @@
     protected override void SetEnabledStateOfControls() {
       base.SetEnabledStateOfControls();
-      instancesComboBox.Enabled = !ReadOnly && !Locked && Content != null && Content.ConsumerCanBeFed;
-      loadButton.Enabled = !ReadOnly && !Locked && Content != null && Content.ConsumerCanBeFed;
+      instancesComboBox.Enabled = !ReadOnly && !Locked && Content != null && Content.Consumer != null;
+      loadButton.Enabled = !ReadOnly && !Locked && Content != null && Content.Consumer != null;
     }
 
     private void loadButton_Click(object sender, EventArgs e) {
-      var instance = (IInstanceDescriptor)instancesComboBox.SelectedItem;
-      if (!Content.FeedConsumer(instance)) {
-        MessageBox.Show("This problem does not support loading the instance " + instance.Name + ".", "Cannot load instance");
+      var descriptor = (IInstanceDescriptor)instancesComboBox.SelectedItem;
+      var instance = Content.LoadInstance(descriptor);
+      if (!Content.Consumer.LoadFrom(instance)) {
+        MessageBox.Show("This problem does not support loading the instance " + descriptor.Name + ".", "Cannot load instance");
+      }
+    }
+
+    private void importButton_Click(object sender, EventArgs e) {
+      if (openFileDialog.ShowDialog() == DialogResult.OK) {
+        T instance = default(T);
+        try {
+          instance = Content.LoadInstance(openFileDialog.FileName);
+        } catch {
+          MessageBox.Show("There was an error parsing the file.", "Error while parsing", MessageBoxButtons.OK, MessageBoxIcon.Error);
+          return;
+        }
+        try {
+          if (!Content.Consumer.LoadFrom(instance)) {
+            MessageBox.Show("This problem does not support loading the instance in the file.", "Cannot load instance", MessageBoxButtons.OK, MessageBoxIcon.Error);
+          }
+        } catch {
+          MessageBox.Show("There was an error while importing the file.");
+        }
       }
     }
@@ -69,9 +91,4 @@
         comboBox.Items.Clear();
     }
-
-    private void instancesComboBox_ToolTipRequired(object sender, ToolTipRequiredEventArgs e) {
-      var instance = (IInstanceDescriptor)instancesComboBox.SelectedItem;
-      e.ToolTip = instance.Description;
-    }
   }
 }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemView.Designer.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemView.Designer.cs	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemView.Designer.cs	(revision 7538)
@@ -103,8 +103,10 @@
       // problemInstanceProviderComboBox
       // 
-      this.problemInstanceProviderComboBox.DrawMode = System.Windows.Forms.DrawMode.OwnerDrawFixed;
+      this.problemInstanceProviderComboBox.DrawMode = System.Windows.Forms.DrawMode.OwnerDrawVariable;
       this.problemInstanceProviderComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.problemInstanceProviderComboBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
       this.problemInstanceProviderComboBox.FormattingEnabled = true;
       this.problemInstanceProviderComboBox.Location = new System.Drawing.Point(50, 5);
+      this.problemInstanceProviderComboBox.MaxDropDownItems = 16;
       this.problemInstanceProviderComboBox.Name = "problemInstanceProviderComboBox";
       this.problemInstanceProviderComboBox.Size = new System.Drawing.Size(173, 21);
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemView.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemView.cs	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemView.cs	(revision 7538)
@@ -63,7 +63,15 @@
       if (problemInstanceProviderComboBox.SelectedIndex >= 0) {
         var provider = (IProblemInstanceProvider)problemInstanceProviderComboBox.SelectedItem;
-        provider.SetConsumer((IProblemInstanceConsumer)Content);
+        var genericType = provider.GetType().GetInterfaces().Single(x => x.IsGenericType && x.GetGenericTypeDefinition() == typeof(IProblemInstanceProvider<>)).GetGenericArguments().First();
+        this.GetType().GetMethod("SetConsumable").MakeGenericMethod(genericType).Invoke(this, new object[] { provider, Content });
         problemInstanceProviderViewHost.Content = provider;
       }
+    }
+
+    /// <summary>
+    /// Do not change method name without changing the string reference above
+    /// </summary>
+    private void SetConsumable<T>(IProblemInstanceProvider<T> producer, IConsumable<T> consumer) {
+      producer.Consumer = consumer;
     }
 
@@ -77,5 +85,5 @@
       var consumerTypes = Content.GetType().GetInterfaces()
         .Where(x => x.IsGenericType
-          && typeof(IProblemInstanceConsumer).IsAssignableFrom(x));
+          && x.GetGenericTypeDefinition() == typeof(IConsumable<>));
 
       if (consumerTypes.Any()) {
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ToolTipComboBox.Designer.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ToolTipComboBox.Designer.cs	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ToolTipComboBox.Designer.cs	(revision 7538)
@@ -48,4 +48,8 @@
       this.toolTip = new System.Windows.Forms.ToolTip(this.components);
       this.SuspendLayout();
+      // 
+      // ToolTipComboBox
+      // 
+      this.MaxDropDownItems = 16;
       this.ResumeLayout(false);
 
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ToolTipComboBox.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ToolTipComboBox.cs	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ToolTipComboBox.cs	(revision 7538)
@@ -29,5 +29,4 @@
 
     private ComboBoxState comboBoxState = ComboBoxState.Normal;
-    private bool mouseOver = false;
 
     public ToolTipComboBox()
@@ -36,15 +35,6 @@
       SetStyle(ControlStyles.UserPaint, true);
       InitializeComponent();
-      DrawMode = System.Windows.Forms.DrawMode.OwnerDrawVariable;
+      DrawMode = System.Windows.Forms.DrawMode.OwnerDrawFixed;
       DropDownStyle = ComboBoxStyle.DropDownList;
-    }
-
-    protected override void OnMeasureItem(MeasureItemEventArgs e) {
-      base.OnMeasureItem(e);
-      string text = GetItemText(Items[e.Index]);
-      if (string.IsNullOrEmpty(text)) text = "test";
-      var rect = TextRenderer.MeasureText(text, Font);
-      e.ItemHeight = rect.Height - 2;
-      e.ItemWidth = rect.Width;
     }
 
@@ -72,7 +62,6 @@
         } else {
           using (var b = new SolidBrush(ForeColor)) {
-            Rectangle r = e.Bounds;
-            r.Offset(0, 1);
-            e.Graphics.DrawString(GetItemText(Items[e.Index]), Font, b, r);
+            var rect = new Rectangle(2, 4, Size.Width - 2, Size.Height - 4);
+            e.Graphics.DrawString(GetItemText(Items[e.Index]), Font, b, rect);
           }
         }
@@ -84,6 +73,6 @@
       base.OnPaint(e);
       if (Enabled == false) comboBoxState = ComboBoxState.Disabled;
-      Rectangle clip = Bounds; // using e.ClipRectangle leads to strange behavior when maximizing/unmaximizing, just redraw the entire region all the time
-      clip.Offset(-clip.X, -clip.Y); // x and y need to be 0
+      Rectangle clip = new Rectangle(new Point(0, 0), Size);
+      clip.Inflate(0, 1);
       if (VisualStyleInformation.IsSupportedByOS && VisualStyleInformation.IsEnabledByUser) {
         PushButtonState pb_State = PushButtonState.Normal;
@@ -109,7 +98,5 @@
         ComboBoxRenderer.DrawDropDownButton(e.Graphics, r, comboBoxState);
       }
-      Rectangle rect = clip;
-      rect.Inflate(-2, -4);
-      rect.Offset(1, 0);
+      var rect = new Rectangle(2, 4, Size.Width - 2, Size.Height - 4);
       if (SelectedIndex > -1 && Items.Count > 0) {
         using (var b = new SolidBrush(ForeColor)) {
@@ -141,5 +128,4 @@
     protected override void OnMouseEnter(EventArgs e) {
       base.OnMouseEnter(e);
-      mouseOver = true;
       if (comboBoxState == ComboBoxState.Normal) {
         comboBoxState = ComboBoxState.Hot;
@@ -158,5 +144,4 @@
     protected override void OnMouseLeave(EventArgs e) {
       base.OnMouseLeave(e);
-      mouseOver = false;
       if (comboBoxState == ComboBoxState.Hot) {
         comboBoxState = ComboBoxState.Normal;
@@ -167,6 +152,8 @@
     protected override void OnMouseDown(MouseEventArgs e) {
       base.OnMouseDown(e);
-      comboBoxState = ComboBoxState.Pressed;
-      Invalidate();
+      if (e.Button == MouseButtons.Left) {
+        comboBoxState = ComboBoxState.Pressed;
+        Invalidate();
+      }
     }
 
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs	(revision 7538)
@@ -39,9 +39,9 @@
   [StorableClass]
   public sealed class GeneralizedQuadraticAssignmentProblem : SingleObjectiveHeuristicOptimizationProblem<IGQAPEvaluator, IGQAPSolutionCreator>, IStorableContent,
-    IProblemInstanceConsumer<IQAPInstance>,
-    IProblemInstanceConsumer<ICTAPInstance>,
-    IProblemInstanceConsumer<ITSPInstance>,
-    IProblemInstanceConsumer<IATSPInstance>,
-    IProblemInstanceConsumer<IGQAPInstance> {
+    IConsumable<QAPInstance>,
+    IConsumable<CTAPInstance>,
+    IConsumable<TSPInstance>,
+    IConsumable<ATSPInstance>,
+    IConsumable<GQAPInstance> {
 
     public override Image ItemImage {
@@ -214,5 +214,5 @@
 
     #region Problem Instance Consumptions
-    public bool LoadFrom(IQAPInstance instance) {
+    public bool LoadFrom(QAPInstance instance) {
       try {
         Name = instance.Name;
@@ -240,5 +240,5 @@
     }
 
-    public bool LoadFrom(ICTAPInstance instance) {
+    public bool LoadFrom(CTAPInstance instance) {
       try {
         Name = instance.Name;
@@ -270,5 +270,5 @@
     }
 
-    public bool LoadFrom(ITSPInstance instance) {
+    public bool LoadFrom(TSPInstance instance) {
       try {
         if (instance.Dimension > 1000) return false;
@@ -304,5 +304,5 @@
     }
 
-    public bool LoadFrom(IATSPInstance instance) {
+    public bool LoadFrom(ATSPInstance instance) {
       try {
         Name = instance.Name;
@@ -336,5 +336,5 @@
     }
 
-    public bool LoadFrom(IGQAPInstance instance) {
+    public bool LoadFrom(GQAPInstance instance) {
       try {
         Name = instance.Name;
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Plugin.cs.frame
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Plugin.cs.frame	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Plugin.cs.frame	(revision 7538)
@@ -25,4 +25,5 @@
   [Plugin("HeuristicLab.Problems.GeneralizedQuadraticAssignment", "3.3.6.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.GeneralizedQuadraticAssignment-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Analysis", "3.3")]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Common", "3.3")]
@@ -33,7 +34,9 @@
   [PluginDependency("HeuristicLab.Operators", "3.3")]
   [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization.Operators", "3.3")]
   [PluginDependency("HeuristicLab.Parameters", "3.3")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
   [PluginDependency("HeuristicLab.Problems.GeneralizedQuadraticAssignment.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.Instances", "3.3")]
   public class HeuristicLabProblemsGeneralizedQuadraticAssignmentPlugin : PluginBase {
   }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/CordeauGQAPInstanceProvider.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/CordeauGQAPInstanceProvider.cs	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/CordeauGQAPInstanceProvider.cs	(revision 7538)
@@ -22,4 +22,5 @@
 using System;
 using System.Collections.Generic;
+using System.IO;
 using System.Linq;
 using System.Reflection;
@@ -27,5 +28,5 @@
 
 namespace HeuristicLab.Problems.Instances.CordeauGQAP {
-  public class CordeauGQAPInstanceProvider : ProblemInstanceProvider<IGQAPInstance> {
+  public class CordeauGQAPInstanceProvider : ProblemInstanceProvider<GQAPInstance> {
     public override string Name {
       get { return "Cordeau et al. GQAP instances"; }
@@ -56,24 +57,44 @@
     }
 
-    public override IGQAPInstance GetInstance(IInstanceDescriptor id) {
+    public override GQAPInstance LoadInstance(IInstanceDescriptor id) {
       var descriptor = (CordeauGQAPInstanceDescriptor)id;
-      var instance = new CordeauGQAPInstance();
       using (var stream = Assembly.GetExecutingAssembly()
         .GetManifestResourceStream(descriptor.InstanceIdentifier)) {
         var parser = new CordeauGQAPParser();
         parser.Parse(stream);
-        if (parser.Error != null) throw parser.Error;
-        instance.Equipments = parser.Equipments;
-        instance.Locations = parser.Locations;
-        instance.Demands = parser.Demands;
-        instance.Capacities = parser.Capacities;
-        instance.Weights = parser.Weights;
-        instance.Distances = parser.Distances;
-        instance.InstallationCosts = parser.InstallationCosts;
-        instance.TransportationCosts = parser.TransportationCosts;
+        var instance = Load(parser);
 
         instance.Name = id.Name;
         instance.Description = id.Description;
+
+        return instance;
       }
+    }
+
+    public override GQAPInstance LoadInstance(string path) {
+      var parser = new CordeauGQAPParser();
+      parser.Parse(path);
+      var instance = Load(parser);
+
+      instance.Name = Path.GetFileName(path);
+      instance.Description = "Loaded from file \"" + path + "\" on " + DateTime.Now.ToString();
+
+      return instance;
+    }
+
+    public override void SaveInstance(GQAPInstance instance, string path) {
+      throw new NotSupportedException();
+    }
+
+    private GQAPInstance Load(CordeauGQAPParser parser) {
+      var instance = new GQAPInstance();
+      instance.Equipments = parser.Equipments;
+      instance.Locations = parser.Locations;
+      instance.Demands = parser.Demands;
+      instance.Capacities = parser.Capacities;
+      instance.Weights = parser.Weights;
+      instance.Distances = parser.Distances;
+      instance.InstallationCosts = parser.InstallationCosts;
+      instance.TransportationCosts = parser.TransportationCosts;
       return instance;
     }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/CordeauGQAPParser.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/CordeauGQAPParser.cs	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/CordeauGQAPParser.cs	(revision 7538)
@@ -34,5 +34,4 @@
     public double[] Demands { get; private set; }
     public double[] Capacities { get; private set; }
-    public Exception Error { get; private set; }
 
     public CordeauGQAPParser() {
@@ -48,10 +47,9 @@
       Demands = null;
       Capacities = null;
-      Error = null;
     }
 
-    public bool Parse(string file) {
+    public void Parse(string file) {
       using (var stream = new FileStream(file, FileMode.Open, FileAccess.Read)) {
-        return Parse(stream);
+        Parse(stream);
       }
     }
@@ -64,62 +62,53 @@
     /// </remarks>
     /// <param name="stream">The stream to read data from.</param>
-    /// <returns>True if the file was successfully read or false otherwise.</returns>
-    public bool Parse(Stream stream) {
-      Error = null;
+    public void Parse(Stream stream) {
       var separator = new char[] { ' ', '\t' };
-      try {
-        StreamReader reader = new StreamReader(stream);
-        string line = Continue(reader);
+      var reader = new StreamReader(stream);
+      string line = Continue(reader);
 
-        var info = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
-        Equipments = int.Parse(info[0]);
-        Locations = int.Parse(info[1]);
-        TransportationCosts = double.Parse(info[2]);
+      var info = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
+      Equipments = int.Parse(info[0]);
+      Locations = int.Parse(info[1]);
+      TransportationCosts = double.Parse(info[2]);
 
+      line = Continue(reader);
+
+      Weights = new double[Equipments, Equipments];
+      for (int i = 0; i < Equipments; i++) {
+        var weightsPerEquipment = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
+        for (int j = 0; j < Equipments; j++) {
+          Weights[i, j] = double.Parse(weightsPerEquipment[j], CultureInfo.InvariantCulture.NumberFormat);
+        }
         line = Continue(reader);
+      }
 
-        Weights = new double[Equipments, Equipments];
-        for (int i = 0; i < Equipments; i++) {
-          var weightsPerEquipment = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
-          for (int j = 0; j < Equipments; j++) {
-            Weights[i, j] = double.Parse(weightsPerEquipment[j], CultureInfo.InvariantCulture.NumberFormat);
-          }
-          line = Continue(reader);
+      Distances = new double[Locations, Locations];
+      for (int i = 0; i < Locations; i++) {
+        var distancePerLocation = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
+        for (int j = 0; j < Locations; j++) {
+          Distances[i, j] = double.Parse(distancePerLocation[j], CultureInfo.InvariantCulture.NumberFormat);
         }
+        line = Continue(reader);
+      }
 
-        Distances = new double[Locations, Locations];
-        for (int i = 0; i < Locations; i++) {
-          var distancePerLocation = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
-          for (int j = 0; j < Locations; j++) {
-            Distances[i, j] = double.Parse(distancePerLocation[j], CultureInfo.InvariantCulture.NumberFormat);
-          }
-          line = Continue(reader);
-        }
+      InstallationCosts = new double[Equipments, Locations];
+      for (int i = 0; i < Equipments; i++) {
+        var costsPerEquipment = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
+        for (int j = 0; j < Locations; j++)
+          InstallationCosts[i, j] = double.Parse(costsPerEquipment[j], CultureInfo.InvariantCulture.NumberFormat);
+        line = Continue(reader);
+      }
 
-        InstallationCosts = new double[Equipments, Locations];
-        for (int i = 0; i < Equipments; i++) {
-          var costsPerEquipment = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
-          for (int j = 0; j < Locations; j++)
-            InstallationCosts[i, j] = double.Parse(costsPerEquipment[j], CultureInfo.InvariantCulture.NumberFormat);
-          line = Continue(reader);
-        }
+      Demands = new double[Equipments];
+      var demandsPerEquipment = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
+      for (int i = 0; i < Equipments; i++)
+        Demands[i] = double.Parse(demandsPerEquipment[i], CultureInfo.InvariantCulture.NumberFormat);
 
-        Demands = new double[Equipments];
-        var demandsPerEquipment = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
-        for (int i = 0; i < Equipments; i++)
-          Demands[i] = double.Parse(demandsPerEquipment[i], CultureInfo.InvariantCulture.NumberFormat);
+      line = Continue(reader);
 
-        line = Continue(reader);
-
-        Capacities = new double[Locations];
-        string[] capacityPerLocation = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
-        for (int i = 0; i < Locations; i++)
-          Capacities[i] = double.Parse(capacityPerLocation[i], CultureInfo.InvariantCulture.NumberFormat);
-
-        return true;
-      } catch (Exception e) {
-        Error = e;
-        return false;
-      }
+      Capacities = new double[Locations];
+      string[] capacityPerLocation = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
+      for (int i = 0; i < Locations; i++)
+        Capacities[i] = double.Parse(capacityPerLocation[i], CultureInfo.InvariantCulture.NumberFormat);
     }
 
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/HeuristicLab.Problems.Instances.CordeauGQAP-3.3.csproj
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/HeuristicLab.Problems.Instances.CordeauGQAP-3.3.csproj	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/HeuristicLab.Problems.Instances.CordeauGQAP-3.3.csproj	(revision 7538)
@@ -111,5 +111,4 @@
     <None Include="Plugin.cs.frame" />
     <Compile Include="CordeauGQAPParser.cs" />
-    <Compile Include="CordeauGQAPInstance.cs" />
     <Compile Include="CordeauGQAPInstanceProvider.cs" />
     <Compile Include="CordeauGQAPInstanceDescriptor.cs" />
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/Plugin.cs.frame
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/Plugin.cs.frame	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.CordeauGQAP/3.3/Plugin.cs.frame	(revision 7538)
@@ -25,4 +25,6 @@
   [Plugin("HeuristicLab.Problems.Instances.CordeauGQAP", "3.3.6.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.Instances.CordeauGQAP-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.Instances", "3.3")]
   public class HeuristicLabProblemsInstancesCordeauGQAPPlugin : PluginBase {
   }
